/*
 * intres - intelligent reside
 *
 * author: hackbard@hackdaworld.org
 *
 */

var config = {
	init: function() {
	}
};

var thermo = {
	init: function() {
		thermo.draw();
		$('#thermo').click(function() {
			thermo.draw_thermos();
		});
	},
	draw: function() {
		thermo.get_thermos();
	},
	get_thermos: function() {
		xhr("POST","cgi-bin/fhemwrapper","list",
		    function(ret) {
			// extract thermos
			var thermos=ret.match(/\ \ MAX_[0-9,a-f]{6}\ /g);
			thermo.get_thermo_details(thermos);
		});
	},
	thermos: {},
	get_thermo_details: function(thermos) {
		for(var th in thermos) {
			var id=thermos[th];
			cl("xhr: list "+id);
			xhr("POST","cgi-bin/fhemwrapper","list "+id,
			    function(ret) {
				var id=ret.match(/NAME.*/)+'';
				id=id.replace(/NAME\s+/,"");
				var alias=ret.match(/alias.*/)+'';
				alias=alias.replace(/alias\s+/,"");
				var state=ret.match(/STATE.*/)+'';
				state=state.replace(/STATE\s+/,"");
				var eco=ret.match(/ecoTemperature.*/)+'';
				eco=eco.replace(/.*ecoTemperature\s+/,"");
				var comfort=ret.match(/comfortTem.*/)+'';
				comfort=comfort.replace(/.*comfortTem.*\s+/,"");
				thermo.thermos[id]={};
				thermo.thermos[id].alias=alias;
				thermo.thermos[id].state=state;
				thermo.thermos[id].eco=eco;
				thermo.thermos[id].comfort=comfort;
				thermo.draw_thermos();
			});
		}
	},
	draw_thermo: function(alias,name,state,eco,comfort,type) {
		var html="<div class=thermo>";
		switch(type) {
		case 'd':
			html+="<div class=thermoalias>"+alias+"</div>";
			html+="<div class=thermoname>"+name+"</div>";
			html+="<div class=thermostate>"+state+"</div>";
			html+="<div class=thermoeco>"+eco+"</div>";
			html+="<div class=thermocomfort>"+comfort+"</div>";
			break;
		case 'h':
			html+="<div class=thermoalias><b>"+alias+"</b></div>";
			html+="<div class=thermoname><b>"+name+"</b></div>";
			html+="<div class=thermostate><b>"+state+"</b></div>";
			html+="<div class=thermoeco><b>"+eco+"</b></div>";
			html+="<div class=thermocomfort><b>"+comfort+
			      "</b></div>";
			break;
		}
		html+="</div>";
		return html;
	},
	draw_thermos: function() {
		var html=thermo.draw_thermo('Alias','Name','State',
		                            'Eco','Comfort','h');
		for(var i in thermo.thermos) {
			var th=thermo.thermos[i];
			html+=thermo.draw_thermo(th.alias,i,th.state,
			                         th.eco,th.comfort,'d');
		}
		$('div#thermobody').html(html);
	}
};

var cmd = {
	init: function() {
		$('#cmdout').css('display','none');
		$('#cmdin').keydown(function(key) {
			if(key.keyCode==13)
				cmd.execute();
		});
	},
	execute: function() {
		var cmdline=$('#cmdin').val();
		xhr("POST","cgi-bin/fhemwrapper",cmdline,function(ret) {
			$('#cmdout').css('display','block');
			$('#cmdouttxt').val(ret);
		});
		$('#cmdin').val("");
	}
};

var intres = {
	init: function() {
		document.addEventListener('deviceready',intres.startup,false);
	},
	startup: function() {
		// cmd
		cmd.init();
		// config
		//config.init();
		// thermostat
		thermo.init();
	}
};

$(document).ready(function() {
	if(Modernizr.hasEvent('deviceready')) {
		intres.init();
	}
	else {
		intres.startup();
	}
});

